/* /////////////////////////////////////////////////////////////////////////////
 * File:        guid_test.cpp
 *
 * Purpose:     Implementation file for the guid_test project.
 *
 * Created:     27th July 2005
 * Updated:     27th July 2005
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright 1999-2005, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2005
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software. 
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage. 
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission. 
 *
 * ////////////////////////////////////////////////////////////////////////// */

/* STLSoft Header Files */
#include <stlsoft.h>

#include <comstl.h>
#include <comstl/guid.hpp>


/* Standard C++ Header Files */
#include <exception>

#ifdef __WATCOMC__
namespace std
{
	using ::exception;
}
#endif /* __WATCOMC__ */

/* Standard C Header Files */
#include <stdio.h>

/* /////////////////////////////////////////////////////////////////////////////
 * Forward declarations
 */


/* ////////////////////////////////////////////////////////////////////////// */

static int main_(int /* argc */, char ** /*argv*/)
{
#if defined(_DEBUG) || \
    defined(__SYNSOFT_DBS_DEBUG)
	puts("guid_test: " __STLSOFT_COMPILER_LABEL_STRING);
#endif /* debug */

	using comstl::guid;

	guid		g1;
	guid		g2(IID_IUnknown);
	guid		g3(g2);

	comstl_assert(g2 == g3);

	try
	{
		guid	g4(stlsoft_ns_qual(c_str_ptr_a)(g3));

		comstl_assert(g4 == g3);

		guid	g5(stlsoft_ns_qual(c_str_ptr_w)(g3));

		comstl_assert(g5 == g3);

		guid	g6(stlsoft_ns_qual(c_str_ptr)(g3));

		comstl_assert(g6 == g3);
	}
	catch(comstl::com_exception &x)
	{
		fprintf(stderr, "Exception: %s\n", x.what());
	}

	try
	{
		guid	g7("lemon scented");
	}
	catch(comstl::com_exception &x)
	{
		fprintf(stderr, "Exception: %s\n", x.what());
	}

    return 0;
}

int main(int argc, char *argv[])
{
#if 0
	::Sleep(100000);
#endif /* 0 */

	try
	{
		return main_(argc, argv);
	}
	catch(std::exception &x)
	{
		fprintf(stderr, "Unhandled error: %s\n", x.what());
	}
	catch(...)
	{
		fprintf(stderr, "Unhandled unknown error\n");
	}

	return EXIT_FAILURE;
}

/* ////////////////////////////////////////////////////////////////////////// */
