/* /////////////////////////////////////////////////////////////////////////////
 * File:        meta_test.cpp
 *
 * Purpose:     Implementation file for the meta_test project.
 *
 * Created:     5th November 2003
 * Updated:     11th June 2005
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright (C) 1999-2003, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2003
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software.
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage.
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission.
 *
 * ////////////////////////////////////////////////////////////////////////// */

#include <stdio.h>

#define	_STLSOFT_NO_NAMESPACE

#define STLSOFT_FORCE_HAS_REFERENCE

#include <stlsoft.h>
#include <stlsoft_meta.h>

/* ////////////////////////////////////////////////////////////////////////// */


/* ////////////////////////////////////////////////////////////////////////// */

char const *c_str_ptr(ss_bool_t b)
{
	return b ? "true" : "false";
}

/* ////////////////////////////////////////////////////////////////////////// */

class X
{
	typedef int	value_type;
	typedef int	const_iterator;
};

class Y
{
public:
	operator int *() const;

	typedef int	*iterator;
	typedef int	&reference;
};

/* ////////////////////////////////////////////////////////////////////////// */

int main(int /* argc */, char ** /*argv*/)
{
	puts("meta_test: " __STLSOFT_COMPILER_LABEL_STRING);

	// Is pointer type?
	{
#define TEST_IS_POINTER_TYPE(T)		printf("  %-40s\t%s\n", "is_pointer_type<" #T ">:", c_str_ptr(is_pointer_type<T>::value))

		printf("Testing is_pointer_type<>:\n");

		TEST_IS_POINTER_TYPE(bool);
		TEST_IS_POINTER_TYPE(char);
		TEST_IS_POINTER_TYPE(signed char);
		TEST_IS_POINTER_TYPE(unsigned char);
		TEST_IS_POINTER_TYPE(short);
		TEST_IS_POINTER_TYPE(ss_sint16_t);
		TEST_IS_POINTER_TYPE(signed short);
		TEST_IS_POINTER_TYPE(unsigned short);
		TEST_IS_POINTER_TYPE(int);
		TEST_IS_POINTER_TYPE(signed int);
		TEST_IS_POINTER_TYPE(unsigned int);
		TEST_IS_POINTER_TYPE(long);
		TEST_IS_POINTER_TYPE(signed long);
		TEST_IS_POINTER_TYPE(unsigned long);
		TEST_IS_POINTER_TYPE(float);
		TEST_IS_POINTER_TYPE(double);
		TEST_IS_POINTER_TYPE(long double);
		TEST_IS_POINTER_TYPE(void);
		TEST_IS_POINTER_TYPE(void*);
		TEST_IS_POINTER_TYPE(X);
		TEST_IS_POINTER_TYPE(X*);
		TEST_IS_POINTER_TYPE(Y);

		printf("\n");
	}

	// Is bool type?
	{
#define TEST_IS_BOOL_TYPE(T)		printf("  %-40s\t%s\n", "is_bool_type<" #T ">:", c_str_ptr(is_bool_type<T>::value))

		printf("Testing is_bool_type<>:\n");

		TEST_IS_BOOL_TYPE(bool);
		TEST_IS_BOOL_TYPE(char);
		TEST_IS_BOOL_TYPE(signed char);
		TEST_IS_BOOL_TYPE(unsigned char);
		TEST_IS_BOOL_TYPE(short);
		TEST_IS_BOOL_TYPE(ss_sint16_t);
		TEST_IS_BOOL_TYPE(signed short);
		TEST_IS_BOOL_TYPE(unsigned short);
		TEST_IS_BOOL_TYPE(int);
		TEST_IS_BOOL_TYPE(signed int);
		TEST_IS_BOOL_TYPE(unsigned int);
		TEST_IS_BOOL_TYPE(long);
		TEST_IS_BOOL_TYPE(signed long);
		TEST_IS_BOOL_TYPE(unsigned long);
		TEST_IS_BOOL_TYPE(float);
		TEST_IS_BOOL_TYPE(double);
		TEST_IS_BOOL_TYPE(long double);
		TEST_IS_BOOL_TYPE(void);
		TEST_IS_BOOL_TYPE(void*);
		TEST_IS_BOOL_TYPE(X);
		TEST_IS_BOOL_TYPE(X*);
		TEST_IS_BOOL_TYPE(Y);

		printf("\n");
	}

	// Is void type?
	{
#define TEST_IS_VOID_TYPE(T)		printf("  %-40s\t%s\n", "is_void_type<" #T ">:", c_str_ptr(is_void_type<T>::value))

		printf("Testing is_void_type<>:\n");

		TEST_IS_VOID_TYPE(bool);
		TEST_IS_VOID_TYPE(char);
		TEST_IS_VOID_TYPE(signed char);
		TEST_IS_VOID_TYPE(unsigned char);
		TEST_IS_VOID_TYPE(short);
		TEST_IS_VOID_TYPE(ss_sint16_t);
		TEST_IS_VOID_TYPE(signed short);
		TEST_IS_VOID_TYPE(unsigned short);
		TEST_IS_VOID_TYPE(int);
		TEST_IS_VOID_TYPE(signed int);
		TEST_IS_VOID_TYPE(unsigned int);
		TEST_IS_VOID_TYPE(long);
		TEST_IS_VOID_TYPE(signed long);
		TEST_IS_VOID_TYPE(unsigned long);
		TEST_IS_VOID_TYPE(float);
		TEST_IS_VOID_TYPE(double);
		TEST_IS_VOID_TYPE(long double);
		TEST_IS_VOID_TYPE(void);
		TEST_IS_VOID_TYPE(void*);
		TEST_IS_VOID_TYPE(X);
		TEST_IS_VOID_TYPE(X*);
		TEST_IS_VOID_TYPE(Y);

		printf("\n");
	}

	// Is integral type?
	{
#define TEST_IS_INTEGRAL_TYPE(T)		printf("  %-40s\t%s\n", "is_integral_type<" #T ">:", c_str_ptr(is_integral_type<T>::value))

		printf("Testing is_integral_type<>:\n");

		TEST_IS_INTEGRAL_TYPE(bool);
		TEST_IS_INTEGRAL_TYPE(char);
		TEST_IS_INTEGRAL_TYPE(signed char);
		TEST_IS_INTEGRAL_TYPE(unsigned char);
		TEST_IS_INTEGRAL_TYPE(short);
		TEST_IS_INTEGRAL_TYPE(ss_sint16_t);
		TEST_IS_INTEGRAL_TYPE(signed short);
		TEST_IS_INTEGRAL_TYPE(unsigned short);
		TEST_IS_INTEGRAL_TYPE(int);
		TEST_IS_INTEGRAL_TYPE(signed int);
		TEST_IS_INTEGRAL_TYPE(unsigned int);
		TEST_IS_INTEGRAL_TYPE(long);
		TEST_IS_INTEGRAL_TYPE(signed long);
		TEST_IS_INTEGRAL_TYPE(unsigned long);
		TEST_IS_INTEGRAL_TYPE(float);
		TEST_IS_INTEGRAL_TYPE(double);
		TEST_IS_INTEGRAL_TYPE(long double);
		TEST_IS_INTEGRAL_TYPE(void);
		TEST_IS_INTEGRAL_TYPE(void*);
		TEST_IS_INTEGRAL_TYPE(X);
		TEST_IS_INTEGRAL_TYPE(X*);
		TEST_IS_INTEGRAL_TYPE(Y);

		printf("\n");
	}

	// Is numeric type?
	{
#define TEST_IS_NUMERIC_TYPE(T)		printf("  %-40s\t%s\n", "is_numeric_type<" #T ">:", c_str_ptr(is_numeric_type<T>::value))

		printf("Testing is_numeric_type<>:\n");

		TEST_IS_NUMERIC_TYPE(bool);
		TEST_IS_NUMERIC_TYPE(char);
		TEST_IS_NUMERIC_TYPE(signed char);
		TEST_IS_NUMERIC_TYPE(unsigned char);
		TEST_IS_NUMERIC_TYPE(short);
		TEST_IS_NUMERIC_TYPE(ss_sint16_t);
		TEST_IS_NUMERIC_TYPE(signed short);
		TEST_IS_NUMERIC_TYPE(unsigned short);
		TEST_IS_NUMERIC_TYPE(int);
		TEST_IS_NUMERIC_TYPE(signed int);
		TEST_IS_NUMERIC_TYPE(unsigned int);
		TEST_IS_NUMERIC_TYPE(long);
		TEST_IS_NUMERIC_TYPE(signed long);
		TEST_IS_NUMERIC_TYPE(unsigned long);
		TEST_IS_NUMERIC_TYPE(float);
		TEST_IS_NUMERIC_TYPE(double);
		TEST_IS_NUMERIC_TYPE(long double);
		TEST_IS_NUMERIC_TYPE(void);
		TEST_IS_NUMERIC_TYPE(void*);
		TEST_IS_NUMERIC_TYPE(X);
		TEST_IS_NUMERIC_TYPE(X*);
		TEST_IS_NUMERIC_TYPE(Y);

		printf("\n");
	}

	// Is fundamental type?
	{
#define TEST_IS_FUNDAMENTAL_TYPE(T)		printf("  %-40s\t%s\n", "is_fundamental_type<" #T ">:", c_str_ptr(is_fundamental_type<T>::value))

		printf("Testing is_fundamental_type<>:\n");

		TEST_IS_FUNDAMENTAL_TYPE(bool);
		TEST_IS_FUNDAMENTAL_TYPE(char);
		TEST_IS_FUNDAMENTAL_TYPE(signed char);
		TEST_IS_FUNDAMENTAL_TYPE(unsigned char);
		TEST_IS_FUNDAMENTAL_TYPE(short);
		TEST_IS_FUNDAMENTAL_TYPE(ss_sint16_t);
		TEST_IS_FUNDAMENTAL_TYPE(signed short);
		TEST_IS_FUNDAMENTAL_TYPE(unsigned short);
		TEST_IS_FUNDAMENTAL_TYPE(int);
		TEST_IS_FUNDAMENTAL_TYPE(signed int);
		TEST_IS_FUNDAMENTAL_TYPE(unsigned int);
		TEST_IS_FUNDAMENTAL_TYPE(long);
		TEST_IS_FUNDAMENTAL_TYPE(signed long);
		TEST_IS_FUNDAMENTAL_TYPE(unsigned long);
		TEST_IS_FUNDAMENTAL_TYPE(float);
		TEST_IS_FUNDAMENTAL_TYPE(double);
		TEST_IS_FUNDAMENTAL_TYPE(long double);
		TEST_IS_FUNDAMENTAL_TYPE(void);
		TEST_IS_FUNDAMENTAL_TYPE(void*);
		TEST_IS_FUNDAMENTAL_TYPE(X);
		TEST_IS_FUNDAMENTAL_TYPE(X*);
		TEST_IS_FUNDAMENTAL_TYPE(Y);

		printf("\n");
	}

#if (	!defined(__STLSOFT_COMPILER_IS_DMC) || \
		__DMC__ >= 0x0835) && \
	(	!defined(__STLSOFT_COMPILER_IS_MWERKS) || \
		(__MWERKS__ & 0xFF00) >= 0x3000) && \
	(	!defined(__STLSOFT_COMPILER_IS_MSVC) || \
		_MSC_VER >= 1310) && \
	!defined(__STLSOFT_COMPILER_IS_WATCOM)

	// Is class type?
	{
#define TEST_IS_CLASS_TYPE(T)		printf("  %-40s\t%s\n", "is_class_type<" #T ">:", c_str_ptr(is_class_type<T>::value))

		printf("Testing is_class_type<>:\n");

		TEST_IS_CLASS_TYPE(bool);
		TEST_IS_CLASS_TYPE(char);
		TEST_IS_CLASS_TYPE(signed char);
		TEST_IS_CLASS_TYPE(unsigned char);
		TEST_IS_CLASS_TYPE(short);
		TEST_IS_CLASS_TYPE(ss_sint16_t);
		TEST_IS_CLASS_TYPE(signed short);
		TEST_IS_CLASS_TYPE(unsigned short);
		TEST_IS_CLASS_TYPE(int);
		TEST_IS_CLASS_TYPE(signed int);
		TEST_IS_CLASS_TYPE(unsigned int);
		TEST_IS_CLASS_TYPE(long);
		TEST_IS_CLASS_TYPE(signed long);
		TEST_IS_CLASS_TYPE(unsigned long);
		TEST_IS_CLASS_TYPE(float);
		TEST_IS_CLASS_TYPE(double);
		TEST_IS_CLASS_TYPE(long double);
		TEST_IS_CLASS_TYPE(void);
		TEST_IS_CLASS_TYPE(void*);
		TEST_IS_CLASS_TYPE(X);
		TEST_IS_CLASS_TYPE(X*);
		TEST_IS_CLASS_TYPE(Y);

		printf("\n");
	}
#endif /* 0 */

	// Is convertible_to_bool?
	{
#define TEST_IS_CONVERTIBLE_TO_BOOL(T)		printf("  %-40s\t%s\n", "is_convertible_to_bool<" #T ">:", c_str_ptr(is_convertible_to_bool<T>::value))

		printf("Testing is_convertible_to_bool<>:\n");

		TEST_IS_CONVERTIBLE_TO_BOOL(bool);
		TEST_IS_CONVERTIBLE_TO_BOOL(char);
		TEST_IS_CONVERTIBLE_TO_BOOL(signed char);
		TEST_IS_CONVERTIBLE_TO_BOOL(unsigned char);
		TEST_IS_CONVERTIBLE_TO_BOOL(short);
		TEST_IS_CONVERTIBLE_TO_BOOL(ss_sint16_t);
		TEST_IS_CONVERTIBLE_TO_BOOL(signed short);
		TEST_IS_CONVERTIBLE_TO_BOOL(unsigned short);
		TEST_IS_CONVERTIBLE_TO_BOOL(int);
		TEST_IS_CONVERTIBLE_TO_BOOL(signed int);
		TEST_IS_CONVERTIBLE_TO_BOOL(unsigned int);
		TEST_IS_CONVERTIBLE_TO_BOOL(long);
		TEST_IS_CONVERTIBLE_TO_BOOL(signed long);
		TEST_IS_CONVERTIBLE_TO_BOOL(unsigned long);
		TEST_IS_CONVERTIBLE_TO_BOOL(float);
		TEST_IS_CONVERTIBLE_TO_BOOL(double);
		TEST_IS_CONVERTIBLE_TO_BOOL(long double);
		TEST_IS_CONVERTIBLE_TO_BOOL(void);
		TEST_IS_CONVERTIBLE_TO_BOOL(void*);
		TEST_IS_CONVERTIBLE_TO_BOOL(X);
		TEST_IS_CONVERTIBLE_TO_BOOL(X*);
		TEST_IS_CONVERTIBLE_TO_BOOL(Y);

		printf("\n");
	}

	// has value_type?
# ifdef STLSOFT_CF_HAS_MEMBER_TYPE_SUPPORTED
	{
#define TEST_HAS_VALUE_TYPE(T)		printf("  %-40s\t%s\n", "has_value_type<" #T ">:", c_str_ptr(has_value_type<T>::value))

		printf("Testing has_value_type<>:\n");

		TEST_HAS_VALUE_TYPE(bool);
		TEST_HAS_VALUE_TYPE(char);
		TEST_HAS_VALUE_TYPE(signed char);
		TEST_HAS_VALUE_TYPE(unsigned char);
		TEST_HAS_VALUE_TYPE(short);
		TEST_HAS_VALUE_TYPE(ss_sint16_t);
		TEST_HAS_VALUE_TYPE(signed short);
		TEST_HAS_VALUE_TYPE(unsigned short);
		TEST_HAS_VALUE_TYPE(int);
		TEST_HAS_VALUE_TYPE(signed int);
		TEST_HAS_VALUE_TYPE(unsigned int);
		TEST_HAS_VALUE_TYPE(long);
		TEST_HAS_VALUE_TYPE(signed long);
		TEST_HAS_VALUE_TYPE(unsigned long);
		TEST_HAS_VALUE_TYPE(float);
		TEST_HAS_VALUE_TYPE(double);
		TEST_HAS_VALUE_TYPE(long double);
		TEST_HAS_VALUE_TYPE(void);
		TEST_HAS_VALUE_TYPE(void*);
		TEST_HAS_VALUE_TYPE(X);
		TEST_HAS_VALUE_TYPE(X*);
		TEST_HAS_VALUE_TYPE(Y);

		printf("\n");
	}
# endif /* STLSOFT_CF_HAS_MEMBER_TYPE_SUPPORTED */

	// has iterator?
# ifdef STLSOFT_CF_HAS_MEMBER_TYPE_SUPPORTED
	{
#define TEST_HAS_ITERATOR(T)		printf("  %-40s\t%s\n", "has_iterator<" #T ">:", c_str_ptr(has_iterator<T>::value))

		printf("Testing has_iterator<>:\n");

		TEST_HAS_ITERATOR(bool);
		TEST_HAS_ITERATOR(char);
		TEST_HAS_ITERATOR(signed char);
		TEST_HAS_ITERATOR(unsigned char);
		TEST_HAS_ITERATOR(short);
		TEST_HAS_ITERATOR(ss_sint16_t);
		TEST_HAS_ITERATOR(signed short);
		TEST_HAS_ITERATOR(unsigned short);
		TEST_HAS_ITERATOR(int);
		TEST_HAS_ITERATOR(signed int);
		TEST_HAS_ITERATOR(unsigned int);
		TEST_HAS_ITERATOR(long);
		TEST_HAS_ITERATOR(signed long);
		TEST_HAS_ITERATOR(unsigned long);
		TEST_HAS_ITERATOR(float);
		TEST_HAS_ITERATOR(double);
		TEST_HAS_ITERATOR(long double);
		TEST_HAS_ITERATOR(void);
		TEST_HAS_ITERATOR(void*);
		TEST_HAS_ITERATOR(X);
		TEST_HAS_ITERATOR(X*);
		TEST_HAS_ITERATOR(Y);

		printf("\n");
	}
# endif /* STLSOFT_CF_HAS_MEMBER_TYPE_SUPPORTED */

	// has reference?
# ifdef STLSOFT_CF_HAS_MEMBER_TYPE_SUPPORTED
	{
#define TEST_HAS_REFERENCE(T)		printf("  %-40s\t%s\n", "has_reference<" #T ">:", c_str_ptr(has_reference<T>::value))

		printf("Testing has_reference<>:\n");

#if 0
		TEST_HAS_REFERENCE(bool);
		TEST_HAS_REFERENCE(char);
		TEST_HAS_REFERENCE(signed char);
		TEST_HAS_REFERENCE(unsigned char);
		TEST_HAS_REFERENCE(short);
		TEST_HAS_REFERENCE(ss_sint16_t);
		TEST_HAS_REFERENCE(signed short);
		TEST_HAS_REFERENCE(unsigned short);
		TEST_HAS_REFERENCE(int);
		TEST_HAS_REFERENCE(signed int);
		TEST_HAS_REFERENCE(unsigned int);
		TEST_HAS_REFERENCE(long);
		TEST_HAS_REFERENCE(signed long);
		TEST_HAS_REFERENCE(unsigned long);
		TEST_HAS_REFERENCE(float);
		TEST_HAS_REFERENCE(double);
		TEST_HAS_REFERENCE(long double);
		TEST_HAS_REFERENCE(void);
		TEST_HAS_REFERENCE(void*);
		TEST_HAS_REFERENCE(X);
		TEST_HAS_REFERENCE(X*);
#endif /* 0 */
		TEST_HAS_REFERENCE(Y);

		printf("\n");
	}
# endif /* STLSOFT_CF_HAS_MEMBER_TYPE_SUPPORTED */

    return 0;
}

/* ////////////////////////////////////////////////////////////////////////// */
