/* /////////////////////////////////////////////////////////////////////////////
 * File:        union_cast_test.cpp
 *
 * Purpose:     Implementation file for the union_cast_test project.
 *
 * Created:     21st December 2003
 * Updated:     6th June 2005
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright (C) 1999-2003, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2003
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software.
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage.
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission.
 *
 * ////////////////////////////////////////////////////////////////////////// */

#include <stdio.h>

#include <stlsoft.h>
#include <stlsoft_union_cast.h>

using stlsoft::sint64_t;

/* ////////////////////////////////////////////////////////////////////////// */

#ifdef __BORLANDC__
# pragma warn -8004
#endif /* __BORLANDC__ */

/* ////////////////////////////////////////////////////////////////////////// */

struct S
{};

class C
{
public:
#if 0
	C()
		: i(*(int*)0)
	{}
#endif /* 0 */
	C(int &i)
		: i(i)
	{}
	C(C const &rhs)
		: i(rhs.i)
	{}
	virtual ~C()
	{}

protected:
	int	&i;
};

/* ////////////////////////////////////////////////////////////////////////// */

int main(int /* argc */, char ** /*argv*/)
{
#if 0
	::Sleep(100000);
#endif /* 0 */

	puts("union_cast_test: " __STLSOFT_COMPILER_LABEL_STRING);

	/* . */
	void		*pv	=	NULL;
	int			i	=	0;
	long		l	=	0;
	float		f	=	0.0;
	double		d	=	0.0;
	sint64_t	i64	=	0;
	S			s;
	C			c(i);

//	stlsoft_constraint_must_be_pod(S);
//	stlsoft_constraint_must_be_pod_or_void(S);
//	stlsoft_constraint_must_be_pod(C);

	pv = stlsoft::union_cast<int*, int>(3);

	pv = stlsoft::union_cast<void*, int>(i);
	pv = stlsoft::union_cast<void*, S*>(&s);
//	pv = stlsoft::union_cast<C*, C*>(&c);

	char			ch		=	'a';
	char const		*pcch	=	&ch;
	wchar_t const	*pcwch	=	stlsoft::union_cast<wchar_t const*, char const*>(pcch);
//	wchar_t			*pwch	=	stlsoft::union_cast<wchar_t*, char const*>(pcch);

	STLSOFT_SUPPRESS_UNUSED(pcwch);
	STLSOFT_SUPPRESS_UNUSED(pv);
	STLSOFT_SUPPRESS_UNUSED(i);
	STLSOFT_SUPPRESS_UNUSED(l);
	STLSOFT_SUPPRESS_UNUSED(f);
	STLSOFT_SUPPRESS_UNUSED(d);
	STLSOFT_SUPPRESS_UNUSED(i64);
	STLSOFT_SUPPRESS_UNUSED(s);
	STLSOFT_SUPPRESS_UNUSED(c);

    return 0;
}

/* ////////////////////////////////////////////////////////////////////////// */
